# -*- encoding: utf-8 -*-

module MMonitor
  
  class Parser # 解析器，负责网页模板解析。

    attr_accessor :body, :items, :item

    def initialize(dom)
      return nil if dom.nil?
       self.body = dom.at(css_path[:body])
      self.items ||= {}
      process unless self.body.nil?
    end

    def process
      self.list.each do |item|
        self.item = item
        id = spu_id
        unless id.nil?
          self.items[id] = {
             provider: self.provider,
                title: title,
               sku_id: sku_id,
            photo_url: photo_url,
            tag_price: tag_price,
                price: price,
            price_url: price_url
          }
        end
      end
    end

    def list # 产品列表
      products = []
      if css_path[:list].is_a?(Array)
        css_path[:list].each do |li|
               dom = self.body.at(li)
          products += dom.css(css_path[:item]) unless dom.nil?
        end
      else
        products += self.body.at(css_path[:list]).css(css_path[:item])
      end
      products
    end

    def extra # 拓展操作

    end

    def pages
      self.body.at(css_path[:pages]).text.to_i
    end

    def total
      if css_path.has_key?(:total)
        squish( self.body.at(css_path[:total]).try(:text) )
      else
        nil
      end
    end

    def page_key
      'page'
    end

    def page(num)
      num
    end

    def get_html(url, params)
      Spider.get_html(url, params)
    end

    def spu_id # 产品ID
      squish( self.item[css_path[:spu_id]] )
    end

    def sku_id # 单品ID
      if css_path.has_key?(:sku_id)
        squish( self.item[css_path[:sku_id]] )
      else
        nil
      end
    end

    def title # 产品标题
      squish( self.item.at(css_path[:title]).try(:text) )
    end

    def photo_url # 产品图片
      self.item.at(css_path[:photo_url])['src']
    end

    def price # 产品售价
      if css_path.has_key?(:price)
        squish( self.item.at(css_path[:price]).try(:text) ).to_f
      else
        nil
      end
    end

    def tag_price # 产品原价（可选）
      if css_path.has_key?(:tag_price)
        squish( self.item.at(css_path[:tag_price]).try(:text) ).to_f
      else
        nil
      end
    end

    def price_url # 产品售价图片（可选）
      if css_path.has_key?(:price_url)
        self.item.at(css_path[:price_url])['src']
      else
        nil
      end
    end

    private

    # 字符处理
    def squish(string)
      string.gsub(/￥|¥/, '').strip.gsub(/\s+/, '') rescue nil
    end

    # 无货产品，通过图片获取价格
    def pirce_from_ocr(price_url)
      str = MMonitor::Spider.get_ocr(price_url)
      str.match( /\d+\.\d+/ ).to_f
    end
  end

end