# -*- encoding: utf-8 -*-

module MMonitor
  module Strategies
    # http://search.jumei.com/?filter=0-11-1&search=%E6%AC%A7%E8%8E%B1%E9%9B%85&from=search_topbar_%E6%AC%A7%E8%8E%B1%E9%9B%85_word_pos1&cat=&bid=1
    class Jumei < MMonitor::Parser
      # 输出的产品
      def provider
        :jumei
      end

      def css_path
        {
          body:      'body>div#container>div#body>div#search_result_wrap>div#search_list_wrap',
          list:      'div.products_wrap>ul',
          item:      'li',
          total:     'div.search_list_head_fiex>div>div.head_pagecount>span',
          pages:     'div.search_list_head_fiex>div>div.head_pageInfo',
          spu_id:    'pid',
          title:     'div>div.s_l_name>a',
          price:     'div > div.search_list_price > span',
          tag_price: 'div > div.search_list_price > del',
          photo_url: 'div>div.s_l_pic>a>img'
        }
      end

      def page_key
        'filter'
      end

      def pages
        self.body.at(css_path[:pages]).text.split('/')[1].to_i
      end

      def page(num)
        "0-11-#{num}"
      end

      def photo_url # 产品图片
        self.item.at(css_path[:photo_url])['original']
      end

    end
  end
end