# -*- encoding: utf-8 -*-

module MMonitor
  module Strategies
    # http://loreal.tmall.com/category.htm?search=y&scene=taobao_shop
    class Tmall < MMonitor::Parser
      # 输出的产品
      def provider
        :tmall
      end

      def css_path
        {
          body:      '#TmshopSrchNav>div',
          list:      'div.J_TItems',
          item:      'dl.item',
          pages:     'div.filter.clearfix.J_TFilter > p > b.ui-page-s-len', # .text.split('/')[1]
          spu_id:    'data-id',
          title:     'dd.detail > a',
          photo_url: 'dt > a:nth-child(1) > img', # 'data-ks-lazyload'
          price:     'dd.detail > div > div.cprice-area > span.c-price'
        }
      end

      def photo_url # 产品图片
        self.item.at(css_path[:photo_url])['data-ks-lazyload']
      end

      def pages
        self.body.at(css_path[:pages]).text.split('/')[1].to_i
      end

      def page_key
        'pageNo'
      end

    end
  end
end